 #include <QtGui>
 #include <cmath>
 #include <iostream>
 #include "cartesiano.h"
using namespace std; 
 Cartesiano::Cartesiano(QWidget *parent)
     : QWidget(parent)
 {
/*    QTimer *timer = new QTimer(this);
     connect(timer, SIGNAL(timeout()), this, SLOT(update()));
     timer->start(1000);
*/
     setWindowTitle(tr("Grafico"));
     resize(800, 600);
 }

 void Cartesiano::set_xy(double x0, double y0, double x1, double y1)
 {
     this->x0=x0; 
     this->y0=y0; 
     this->x1=x1; 
     this->y1=y1;
 }


 void Cartesiano::plot_axis()
 {
     QPainter painter(this);
     painter.setRenderHint(QPainter::Antialiasing);
    
     int pxsize=15;
     float px0=x0/fabs(x1-x0)*width();
     float py0=-y1/fabs(y1-y0)*height();
     float px1=x1/fabs(x1-x0)*width();
     float py1=-y0/fabs(y1-y0)*height();
     float yassex=0;
     float xassey=0;

     QLineF line(px1,yassex,px0,yassex); 
     QFont newFont = font();
     newFont.setPixelSize(pxsize);
     setFont(newFont);
     QFontMetrics fontMetrics(newFont);
     
     painter.save();
     
     painter.translate(-px0,-py0);
     

    // painter.drawText(xassey-pxsize,yassex+pxsize,"0");


     double dx=(int)log10(fabs(x1-x0));
     if(fabs(x1-x0)/pow(10,dx)<.3) dx--;
     if(fabs(x1-x0)/pow(10,dx)>3.) dx++;
     dx=pow(10.,dx-1);
     double x=floor(x0/dx)*dx; 
     double xt;
     double dy=(int)log10(fabs(y1-y0));
     if(fabs(y1-y0)/pow(10,dy)<.3) dy--;
     if(fabs(y1-y0)/pow(10,dy)>3.) dy++;
     dy=pow(10.,dy-1);
     double y=floor(y0/dy)*dy; 
     double yt;
     QString qs;
     if(x1*x0>=0) xassey=(x+dx)/fabs(x0-x1)*width();
     if(y1*y0>=0) yassex=-(y+dy)/fabs(y0-y1)*height();
     while(y<y1){
	     y=y+dy;
	     if(fabs(y)<dy) continue;
	     yt=-y/fabs(y0-y1)*height();
             line=QLineF(xassey-pxsize/3,yt,xassey+pxsize/3,yt); 
	     painter.drawLine(line);
	     qs.setNum(y);
             painter.drawText(xassey+pxsize,yt+pxsize/3,qs);
     }

     while(x<x1){
	     x=x+dx;
	     if(fabs(x)<dx) x=0;
	     xt=x/fabs(x0-x1)*width();
             line=QLineF(xt,yassex-pxsize/3,xt,yassex+pxsize/3); 
	     painter.drawLine(line);
	     qs.setNum(x);
             painter.drawText(xt-pxsize/2,yassex+pxsize,qs);
     }


     line=QLineF(px1,yassex,px0,yassex); 
     painter.drawLine(line);
     line=QLineF(xassey,py0,xassey,py1); 
     painter.drawLine(line);
     

     painter.drawText(xassey+pxsize/3,py0+pxsize,"y");
     painter.drawText(px1-pxsize,yassex-pxsize/3,"x");

     painter.restore();
 }

void Cartesiano::paintEvent(QPaintEvent *)
 {
     QPainter painter(this);
     this->plot_axis();	 
     // set scale & x0,y0  
/*
     painter.scale((width()) /fabs(x1-x0), -(height())/fabs(y1-y0));
     painter.translate(-x0, -y1);
     
   
     QLineF line(x0,y0,x1,y1); 
     painter.drawLine(line);
     
     int np=100;
     QPointF points[np];
     double dh=fabs(x1-x0)/np;
     double x; 
     for(int i=0; i<np; i++){
	x=x0+dh*i;     
        points[i] = QPointF(x,sin(x));
     }
     

     painter.drawPolyline(points, np);

     QColor mycolor(127,0,127);
     painter.setBrush(mycolor);
     
     for(int i=0; i<np; i++){
	x=x0+dh*i;     
        points[i] = QPointF(x,cos(x));
     }

     painter.drawPoints(points, np);
     */
 }
